<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
			<el-form-item label="来料时间" prop="incomeTimeArray">
                <el-date-picker
				v-model="queryParams.incomeTimeArray"
				format="yyyy-MM-dd HH:mm:ss"
				type="datetimerange"
				range-separator="至"
				start-placeholder="开始日期"
				end-placeholder="结束日期">
				</el-date-picker>
			</el-form-item>
			<el-form-item label="供应商" prop="incomeTimeArray1">
			<!--
				<el-select v-model="form.mtart" placeholder="请选择物料类别" style="width:320px">
					<el-option
					v-for="dict in dict.type.material_type"
					:key="dict.value"
					:label="dict.label"
					:value="dict.value"
					></el-option>
				</el-select>-->
			</el-form-item>
			<el-form-item>
				<el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
				<el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button
					type="warning"
					plain
					icon="el-icon-download"
					size="mini"
					@click="handleExport"
					v-hasPermi="['mes:rfidProcess:export']"
				>导出</el-button>
			</el-col>
			<right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>

		<el-table v-loading="loading" :data="rfidProcessList" @selection-change="handleSelectionChange">
			<el-table-column type="selection" width="55" align="center" />
			<!-- 序号 -->
			<el-table-column type="index" align="center" :index="indexMethod" label="序号" fixed/>
			<el-table-column label="工单编号" align="center" prop="workorderCode" width="200" fixed/>
			<el-table-column label="订单编号" align="center" prop="orderCode" width="200"/>
			<el-table-column label="产品编码" align="center" prop="productCode" width="200"/>
			<el-table-column label="产品名称" align="center" prop="productName" width="200"/>
			<el-table-column label="生产时间" align="center" prop="productDate" width="200"/>
			<el-table-column label="班次" align="center" prop="shiftId" >
				<template slot-scope="scope">
				<span v-if="scope.row.shiftId == 5">白班</span>
				<span v-else>夜班</span>
				</template>
			</el-table-column>
			<el-table-column label="rfid号" align="center" prop="rfid" width="180"/>
			<el-table-column label="工厂编码" align="center" prop="factoryCode" />
			<el-table-column label="机台编码" align="center" prop="machineCode" />
			<el-table-column label="当前步工序编码" align="center" prop="nowProcessCode" width="150"/>
			<el-table-column label="当前步工序名称" align="center" prop="nowProcessName" width="150"/>
			<el-table-column label="下一步工序编码" align="center" prop="nextProcessCode" width="150"/>
			<el-table-column label="下一步工序名称" align="center" prop="nextProcessName" width="150"/>
			<el-table-column label="工序步骤" align="center" prop="orderNum" />
			<el-table-column label="入时间" align="center" prop="inTime" width="180">
				<template slot-scope="scope">
				<span>{{ parseTime(scope.row.inTime, '{y}-{m}-{d}') }}</span>
				{{ parseTime(scope.row.inTime, '{h}:{m}:{s}') }}
						</template>
					</el-table-column>
					<el-table-column label="出时间" align="center" prop="outTime" width="180">
						<template slot-scope="scope">
				<span>{{ parseTime(scope.row.outTime, '{y}-{m}-{d}') }}</span>
				<span>{{ parseTime(scope.row.outTime, '{h}:{m}:{s}') }}</span>
						</template>
					</el-table-column>
					<el-table-column label="状态" align="center" prop="status">
					<template slot-scope="scope">
				{{ scope.row.status == "0" ? "待办" : "完成" }}
				</template>
			</el-table-column>
			<el-table-column label="备注" align="center" prop="remark" />
		</el-table>

		<pagination
			v-show="total>0"
			:total="total"
			:page.sync="queryParams.pageNum"
			:limit.sync="queryParams.pageSize"
			@pagination="getList"
		/>

	</div>
</template>

<script>
import { getIncomeTableList,getTest} from "@/api/quality/qcTable";

export default {
	name: "RfidProcess",
	data() {
		return {
			// 遮罩层
			loading: true,
			// 选中数组
			ids: [],
			// 非单个禁用
			single: true,
			// 非多个禁用
			multiple: true,
			// 显示搜索条件
			showSearch: true,
			// 总条数
			total: 0,
			// 生产rfid流程表格数据
			rfidProcessList: [],
			// 弹出层标题
			title: "",
			// 是否显示弹出层
			open: false,
			// 查询参数
			queryParams: {
				incomeTimeArray: [],
				checkTimeArray: [],
				pageNum: 1,
				pageSize: 10,
				workorderId: null,
				rfid: null,
				factoryCode: null,
				machineCode: null,
				nowProcessId: null,
				nextProcessId: null,
				orderNum: null,
				inTime: null,
				outTime: null,
				status: null,
				shiftId: null,
				productCode: null,
				productName: null,
				productDate: null
			},
			// 表单参数
			form: {},
			// 表单校验
			rules: {
				workorderId: [
					{ required: true, message: "工单ID不能为空", trigger: "blur" }
				],
				rfid: [
					{ required: true, message: "rfid号不能为空", trigger: "blur" }
				],
			}
		};
	},
	created() {
		this.getDate();
		this.getList();
	},
	methods: {
        /**获取默认查询时间段**/
		getDate() {
			let start = this.Fungetdate (0)
			let end = this.Fungetdate (1)
			this.queryParams.incomeTimeArray.push(start,end)
			//this.queryParams.checkTimeArray.push(start,end)
		},
		Fungetdate (num) {
			var dd = new Date();
			dd.setDate(dd.getDate() + num);
			var y = dd.getFullYear();
			var m = dd.getMonth() + 1;//获取当前月份的日期
			var d = dd.getDate();
			return y + "-" + m + "-" + d+" 00:00:00";
		},
		/** 查询生产rfid流程列表 */
		getList() {
			this.loading = true;
			getIncomeTableList(this.queryParams).then(response => {
				this.rfidProcessList = response.rows;
				this.total = response.total;
				this.loading = false;
			});
		},
		// 取消按钮
		cancel() {
			this.open = false;
			this.reset();
		},
		// 表单重置
		reset() {
			this.form = {
				recordId: null,
				workorderId: null,
				rfid: null,
				factoryCode: null,
				machineCode: null,
				nowProcessId: null,
				nextProcessId: null,
				orderNum: null,
				inTime: null,
				outTime: null,
				status: null,
				remark: null,
				attr1: null,
				attr2: null,
				attr3: null,
				attr4: null,
				createBy: null,
				createTime: null,
				updateBy: null,
				updateTime: null,
        shiftId: null
			};
			this.resetForm("form");
		},
		/** 搜索按钮操作 */
		handleQuery() {
			this.queryParams.pageNum = 1;
			this.getList();
		},
		/** 重置按钮操作 */
		resetQuery() {
			this.resetForm("queryForm");
			this.handleQuery();
		},
		// 多选框选中数据
		handleSelectionChange(selection) {
			this.ids = selection.map(item => item.recordId)
			this.single = selection.length!==1
			this.multiple = !selection.length
		},
		/** 新增按钮操作 */
		handleAdd() {
			this.reset();
			this.open = true;
			this.title = "添加生产rfid流程";
		},
		/** 修改按钮操作 */
		handleUpdate(row) {
			this.reset();
			const recordId = row.recordId || this.ids
			getRfidProcess(recordId).then(response => {
				this.form = response.data;
				this.open = true;
				this.title = "修改生产rfid流程";
			});
		},
		/** 提交按钮 */
		submitForm() {
			this.$refs["form"].validate(valid => {
				if (valid) {
					if (this.form.recordId != null) {
						updateRfidProcess(this.form).then(response => {
							this.$modal.msgSuccess("修改成功");
							this.open = false;
							this.getList();
						});
					} else {
						addRfidProcess(this.form).then(response => {
							this.$modal.msgSuccess("新增成功");
							this.open = false;
							this.getList();
						});
					}
				}
			});
		},
		/** 删除按钮操作 */
		handleDelete(row) {
			const recordIds = row.recordId || this.ids;
			this.$modal.confirm('是否确认删除生产rfid流程编号为"' + recordIds + '"的数据项？').then(function() {
				return delRfidProcess(recordIds);
			}).then(() => {
				this.getList();
				this.$modal.msgSuccess("删除成功");
			}).catch(() => {});
		},
		/** 导出按钮操作 */
		handleExport() {
			this.download('mes/rfidProcess/export', {
				...this.queryParams
			}, `rfidProcess_${new Date().getTime()}.xlsx`)
		}
	}
};
</script>
